//Imports
import com.GameInterface.Chat;
import com.GameInterface.DistributedValue;
import com.GameInterface.GUIModuleIF;
import com.GameInterface.InventoryItem;
import com.GameInterface.NeedGreed;
import com.GameInterface.Utils;
import com.Utils.Archive;
import com.Utils.GlobalSignal;
import com.Utils.ID32;
import DPSWindow;

//Constants
var m_Window:MovieClip;
var m_OptionsWindow:MovieClip;

//Properties
var m_NeedGreedWindows:Object;
var m_WindowVisibility:DistributedValue;

//On Load
function onLoad():Void
{
    m_WindowVisibility = DistributedValue.Create( "DamagePane" );

	m_Window = attachMovie("DPSWindow", "dps_window", getNextHighestDepth());
	m_Window._x = 50;
	m_Window._y = 50;

	m_OptionsWindow = attachMovie("DPSOptionsWindow", "m_OptionsWindow", getNextHighestDepth());
	m_OptionsWindow._visible = false;
	
	
//	m_Window._xscale = 125;
//	m_Window._yscale = 125;
	
	m_Window.SignalPositionChanged.Connect(onPositionChanged, this);
	m_Window.SignalClosedWindow.Connect(onWindowClosed, this);
	
	
	ResetFocus();
}

function OnModuleActivated(config:Archive)
{
    var pos:Array = config.FindEntryArray("pos");
	
	if (pos == undefined || pos.length < 2)
		pos = [50, 50];
		
	m_Window._x = pos[0];
	m_Window._y = pos[1];
	
	var alpha:Number = config.FindEntry("WindowAlpha", 100.0);
	m_Window._alpha = alpha;
}

function OnModuleDeactivated()
{
	return CreateConfig();
}

function CreateConfig():Archive
{
    var archive:Archive = new Archive();
	
	archive.AddEntry("pos", m_Window._x);
	archive.AddEntry("pos", m_Window._y);
	archive.AddEntry("WindowAlpha", m_Window._alpha);
	
    return archive;
}

function onPositionChanged(incX:Number, incY:Number) {
	m_Window.x = incX;
	m_Window.y = incY;
}

function onWindowClosed() {
//    m_WindowVisibility.SetValue(false);
	m_OptionsWindow._x = m_Window._x;
	m_OptionsWindow._y = m_Window._y;
	m_OptionsWindow._visible = true;
}

function ResetFocus() {
	Selection.setFocus(null);
}


