import com.Utils.ID32;
import Enums.AttackResultType;
import Enums.CombatLogFeedbackType;
import Enums.InfoContext;


/**
 * ...
 * @author Xxx
 */
class StatRecord
{
	public var combatLogFeedbackType:Number;
	public var iconColorLine:Number;
	public var iconID:ID32;
	public var targetID:ID32;
	public var context:Number;
	public var attackDefensiveLevel:Number;
	public var attackOffensiveLevel:Number;
	public var attackType:Number;
	public var attackResultType:Number;
	public var absorb:Number;
	public var damage:Number;
	public var statID:Number;
	
	public function StatRecord(statID:Number, 
			damage:Number, 
			absorb:Number, 
			attackResultType:Number, 
			attackType:Number,  
			attackOffensiveLevel:Number, 
			attackDefensiveLevel:Number, 
			context:Number, 
			targetID:ID32, 
			iconID:ID32, 
			iconColorLine:Number, 
			combatLogFeedbackType:Number) 
	{
		this.combatLogFeedbackType = combatLogFeedbackType;
		this.iconColorLine = iconColorLine;
		this.iconID = iconID;
		this.targetID = targetID;
		this.context = context;
		this.attackDefensiveLevel = attackDefensiveLevel;
		this.attackOffensiveLevel = attackOffensiveLevel;
		this.attackType = attackType;
		this.attackResultType = attackResultType;
		this.absorb = absorb;
		this.damage = damage;
		this.statID = statID;
	}
	
	public function isSupport():Boolean
	{
		return attackResultType == _global.Enums.AttackResultType.e_AttackType_SpellHeal || attackResultType == _global.Enums.AttackResultType.e_AttackType_SpellCriticalHeal || (combatLogFeedbackType != undefined  && combatLogFeedbackType > -1);
	}
	
	public function isHeal():Boolean
	{
		return isSupport() && !isBarrier();
	}

	public function isBarrier():Boolean
	{
		if (this.combatLogFeedbackType != undefined)
			return (this.combatLogFeedbackType == _global.Enums.CombatLogFeedbackType.e_BarrierIncreased || this.combatLogFeedbackType == _global.Enums.CombatLogFeedbackType.e_BarrierIncreasedCritical);
		return false;
	}
	
	public function isInflict():Boolean
	{
		return (this.context == _global.Enums.InfoContext.e_FromPlayer);
	}
	
	public function isObtained():Boolean
	{
		return (this.context == _global.Enums.InfoContext.e_ToPlayer);
	}
}

